Index: trunk/src/VBox/Additions/x11/xgraphics/Makefile.kmk
===================================================================
--- trunk/src/VBox/Additions/x11/xgraphics/Makefile.kmk	(revision 6618)
+++ trunk/src/VBox/Additions/x11/xgraphics/Makefile.kmk	(revision 6619)
@@ -44,58 +44,58 @@
 ifdef ARGB_CURSORS
 vboxvideo_drv_INCS = \
-	../x11include/4.3/include \
-	../x11include/4.3/include/extensions \
-	../x11include/4.3/include/fonts \
-	../x11include/4.3/programs/Xserver/afb \
-	../x11include/4.3/programs/Xserver/include \
-	../x11include/4.3/programs/Xserver/fb \
-	../x11include/4.3/programs/Xserver/hw/xfree86 \
-	../x11include/4.3/programs/Xserver/hw/xfree86/common \
-	../x11include/4.3/programs/Xserver/hw/xfree86/ddc \
-	../x11include/4.3/programs/Xserver/hw/xfree86/int10 \
-	../x11include/4.3/programs/Xserver/hw/xfree86/i2c \
-	../x11include/4.3/programs/Xserver/hw/xfree86/os-support \
-	../x11include/4.3/programs/Xserver/hw/xfree86/vbe \
-	../x11include/4.3/programs/Xserver/hw/xfree86/os-support/bus \
-	../x11include/4.3/programs/Xserver/hw/xfree86/rac \
-	../x11include/4.3/programs/Xserver/hw/xfree86/ramdac \
-	../x11include/4.3/programs/Xserver/hw/xfree86/shadowfb \
-	../x11include/4.3/programs/Xserver/hw/xfree86/vgahw \
-	../x11include/4.3/programs/Xserver/hw/xfree86/xf1bpp \
-	../x11include/4.3/programs/Xserver/hw/xfree86/xf24_32bpp \
-	../x11include/4.3/programs/Xserver/hw/xfree86/xf4bpp \
-	../x11include/4.3/programs/Xserver/mfb \
-	../x11include/4.3/programs/Xserver/mi \
-	../x11include/4.3/programs/Xserver/miext/shadow \
-	../x11include/4.3/programs/Xserver/render \
-	../x11include/4.3/programs/Xserver/Xext
+	$(VBOX_PATH_X11_XFREE_4_3)/include \
+	$(VBOX_PATH_X11_XFREE_4_3)/include/extensions \
+	$(VBOX_PATH_X11_XFREE_4_3)/include/fonts \
+	$(VBOX_PATH_X11_XFREE_4_3)/programs/Xserver/afb \
+	$(VBOX_PATH_X11_XFREE_4_3)/programs/Xserver/include \
+	$(VBOX_PATH_X11_XFREE_4_3)/programs/Xserver/fb \
+	$(VBOX_PATH_X11_XFREE_4_3)/programs/Xserver/hw/xfree86 \
+	$(VBOX_PATH_X11_XFREE_4_3)/programs/Xserver/hw/xfree86/common \
+	$(VBOX_PATH_X11_XFREE_4_3)/programs/Xserver/hw/xfree86/ddc \
+	$(VBOX_PATH_X11_XFREE_4_3)/programs/Xserver/hw/xfree86/int10 \
+	$(VBOX_PATH_X11_XFREE_4_3)/programs/Xserver/hw/xfree86/i2c \
+	$(VBOX_PATH_X11_XFREE_4_3)/programs/Xserver/hw/xfree86/os-support \
+	$(VBOX_PATH_X11_XFREE_4_3)/programs/Xserver/hw/xfree86/vbe \
+	$(VBOX_PATH_X11_XFREE_4_3)/programs/Xserver/hw/xfree86/os-support/bus \
+	$(VBOX_PATH_X11_XFREE_4_3)/programs/Xserver/hw/xfree86/rac \
+	$(VBOX_PATH_X11_XFREE_4_3)/programs/Xserver/hw/xfree86/ramdac \
+	$(VBOX_PATH_X11_XFREE_4_3)/programs/Xserver/hw/xfree86/shadowfb \
+	$(VBOX_PATH_X11_XFREE_4_3)/programs/Xserver/hw/xfree86/vgahw \
+	$(VBOX_PATH_X11_XFREE_4_3)/programs/Xserver/hw/xfree86/xf1bpp \
+	$(VBOX_PATH_X11_XFREE_4_3)/programs/Xserver/hw/xfree86/xf24_32bpp \
+	$(VBOX_PATH_X11_XFREE_4_3)/programs/Xserver/hw/xfree86/xf4bpp \
+	$(VBOX_PATH_X11_XFREE_4_3)/programs/Xserver/mfb \
+	$(VBOX_PATH_X11_XFREE_4_3)/programs/Xserver/mi \
+	$(VBOX_PATH_X11_XFREE_4_3)/programs/Xserver/miext/shadow \
+	$(VBOX_PATH_X11_XFREE_4_3)/programs/Xserver/render \
+	$(VBOX_PATH_X11_XFREE_4_3)/programs/Xserver/Xext
 else
 vboxvideo_drv_INCS = \
-	../x11include/4.2/exports/include/X11 \
-	../x11include/4.2/include \
-	../x11include/4.2/include/extensions \
-	../x11include/4.2/include/fonts \
-	../x11include/4.2/programs/Xserver/afb \
-	../x11include/4.2/programs/Xserver/include \
-	../x11include/4.2/programs/Xserver/fb \
-	../x11include/4.2/programs/Xserver/hw/xfree86/common \
-	../x11include/4.2/programs/Xserver/hw/xfree86/ddc \
-	../x11include/4.2/programs/Xserver/hw/xfree86/int10 \
-	../x11include/4.2/programs/Xserver/hw/xfree86/i2c \
-	../x11include/4.2/programs/Xserver/hw/xfree86/os-support \
-	../x11include/4.2/programs/Xserver/hw/xfree86/os-support/bus \
-	../x11include/4.2/programs/Xserver/hw/xfree86/os-support/vbe \
-	../x11include/4.2/programs/Xserver/hw/xfree86/rac \
-	../x11include/4.2/programs/Xserver/hw/xfree86/ramdac \
-	../x11include/4.2/programs/Xserver/hw/xfree86/shadowfb \
-	../x11include/4.2/programs/Xserver/hw/xfree86/vgahw \
-	../x11include/4.2/programs/Xserver/hw/xfree86/xf1bpp \
-	../x11include/4.2/programs/Xserver/hw/xfree86/xf24_32bpp \
-	../x11include/4.2/programs/Xserver/hw/xfree86/xf4bpp \
-	../x11include/4.2/programs/Xserver/mfb \
-	../x11include/4.2/programs/Xserver/mi \
-	../x11include/4.2/programs/Xserver/miext/shadow \
-	../x11include/4.2/programs/Xserver/render \
-	../x11include/4.2/programs/Xserver/Xext
+	$(VBOX_PATH_X11_XFREE_4_2)/exports/include/X11 \
+	$(VBOX_PATH_X11_XFREE_4_2)/include \
+	$(VBOX_PATH_X11_XFREE_4_2)/include/extensions \
+	$(VBOX_PATH_X11_XFREE_4_2)/include/fonts \
+	$(VBOX_PATH_X11_XFREE_4_2)/programs/Xserver/afb \
+	$(VBOX_PATH_X11_XFREE_4_2)/programs/Xserver/include \
+	$(VBOX_PATH_X11_XFREE_4_2)/programs/Xserver/fb \
+	$(VBOX_PATH_X11_XFREE_4_2)/programs/Xserver/hw/xfree86/common \
+	$(VBOX_PATH_X11_XFREE_4_2)/programs/Xserver/hw/xfree86/ddc \
+	$(VBOX_PATH_X11_XFREE_4_2)/programs/Xserver/hw/xfree86/int10 \
+	$(VBOX_PATH_X11_XFREE_4_2)/programs/Xserver/hw/xfree86/i2c \
+	$(VBOX_PATH_X11_XFREE_4_2)/programs/Xserver/hw/xfree86/os-support \
+	$(VBOX_PATH_X11_XFREE_4_2)/programs/Xserver/hw/xfree86/os-support/bus \
+	$(VBOX_PATH_X11_XFREE_4_2)/programs/Xserver/hw/xfree86/os-support/vbe \
+	$(VBOX_PATH_X11_XFREE_4_2)/programs/Xserver/hw/xfree86/rac \
+	$(VBOX_PATH_X11_XFREE_4_2)/programs/Xserver/hw/xfree86/ramdac \
+	$(VBOX_PATH_X11_XFREE_4_2)/programs/Xserver/hw/xfree86/shadowfb \
+	$(VBOX_PATH_X11_XFREE_4_2)/programs/Xserver/hw/xfree86/vgahw \
+	$(VBOX_PATH_X11_XFREE_4_2)/programs/Xserver/hw/xfree86/xf1bpp \
+	$(VBOX_PATH_X11_XFREE_4_2)/programs/Xserver/hw/xfree86/xf24_32bpp \
+	$(VBOX_PATH_X11_XFREE_4_2)/programs/Xserver/hw/xfree86/xf4bpp \
+	$(VBOX_PATH_X11_XFREE_4_2)/programs/Xserver/mfb \
+	$(VBOX_PATH_X11_XFREE_4_2)/programs/Xserver/mi \
+	$(VBOX_PATH_X11_XFREE_4_2)/programs/Xserver/miext/shadow \
+	$(VBOX_PATH_X11_XFREE_4_2)/programs/Xserver/render \
+	$(VBOX_PATH_X11_XFREE_4_2)/programs/Xserver/Xext
 endif
 vboxvideo_drv_SOURCES = \
@@ -114,7 +114,7 @@
 vboxvideo_drv_70_LDFLAGS = -s
 vboxvideo_drv_70_INCS = \
-	../x11include/7.0 \
-	../x11include/7.0/X11 \
-	../x11include/7.0/xorg
+	$(VBOX_PATH_X11_XORG_7_0) \
+	$(VBOX_PATH_X11_XORG_7_0)/X11 \
+	$(VBOX_PATH_X11_XORG_7_0)/xorg
 vboxvideo_drv_70_SOURCES  = \
 	vboxvideo_70.c \
@@ -130,7 +130,7 @@
 vboxvideo_drv_71_LDFLAGS = -s
 vboxvideo_drv_71_INCS = \
-	../x11include/7.1 \
-	../x11include/7.1/X11 \
-	../x11include/7.1/xorg
+	$(VBOX_PATH_X11_XORG_7_1) \
+	$(VBOX_PATH_X11_XORG_7_1)/X11 \
+	$(VBOX_PATH_X11_XORG_7_1)/xorg
 vboxvideo_drv_71_SOURCES  = \
 	vboxvideo_70.c \
@@ -146,7 +146,7 @@
 vboxvideo_drv_13_LDFLAGS = -s
 vboxvideo_drv_13_INCS = \
-	../x11include/1.3 \
-	../x11include/1.3/X11 \
-	../x11include/1.3/xorg
+	$(VBOX_PATH_X11_XORG_1_3) \
+	$(VBOX_PATH_X11_XORG_1_3)/X11 \
+	$(VBOX_PATH_X11_XORG_1_3)/xorg
 vboxvideo_drv_13_SOURCES  = \
 	vboxvideo_13.c \
@@ -162,7 +162,7 @@
 vboxvideo_drv_14_LDFLAGS = -s
 vboxvideo_drv_14_INCS = \
-	../x11include/1.4 \
-	../x11include/1.4/X11 \
-	../x11include/1.4/xorg
+	$(VBOX_PATH_X11_XORG_1_4) \
+	$(VBOX_PATH_X11_XORG_1_4)/X11 \
+	$(VBOX_PATH_X11_XORG_1_4)/xorg
 # The actual source has not changed from the 1.3 driver, but the headers
 # have.  To be safe, build the driver for 1.4 separately.
@@ -184,7 +184,7 @@
 	IN_RING3 VBOX XORG_7X RENDER=1
 vboxvideo_drv_INCS = \
-	../x11include/7.1 \
-	../x11include/7.1/X11 \
-	../x11include/7.1/xorg
+	$(VBOX_PATH_X11_XORG_7_1) \
+	$(VBOX_PATH_X11_XORG_7_1)/X11 \
+	$(VBOX_PATH_X11_XORG_7_1)/xorg
 vboxvideo_drv_SOURCES  = \
 	vboxvideo_70.c \
Index: trunk/src/VBox/Additions/x11/xmouse/Makefile.kmk
===================================================================
--- trunk/src/VBox/Additions/x11/xmouse/Makefile.kmk	(revision 6618)
+++ trunk/src/VBox/Additions/x11/xmouse/Makefile.kmk	(revision 6619)
@@ -41,13 +41,13 @@
 vboxmouse_drv_LDFLAGS.release = -S
 vboxmouse_drv_INCS := \
-	../x11include/4.2/exports/include/X11 \
-	../x11include/4.2/include \
-	../x11include/4.2/include/extensions \
-	../x11include/4.2/programs/Xserver/include \
-	../x11include/4.2/programs/Xserver/hw/xfree86 \
-	../x11include/4.2/programs/Xserver/hw/xfree86/common \
-	../x11include/4.2/programs/Xserver/hw/xfree86/os-support \
-	../x11include/4.2/programs/Xserver/hw/xfree86/os-support/bus \
-	../x11include/4.2/programs/Xserver/mi \
+	$(VBOX_PATH_X11_XFREE_4_2)/exports/include/X11 \
+	$(VBOX_PATH_X11_XFREE_4_2)/include \
+	$(VBOX_PATH_X11_XFREE_4_2)/include/extensions \
+	$(VBOX_PATH_X11_XFREE_4_2)/programs/Xserver/include \
+	$(VBOX_PATH_X11_XFREE_4_2)/programs/Xserver/hw/xfree86 \
+	$(VBOX_PATH_X11_XFREE_4_2)/programs/Xserver/hw/xfree86/common \
+	$(VBOX_PATH_X11_XFREE_4_2)/programs/Xserver/hw/xfree86/os-support \
+	$(VBOX_PATH_X11_XFREE_4_2)/programs/Xserver/hw/xfree86/os-support/bus \
+	$(VBOX_PATH_X11_XFREE_4_2)/programs/Xserver/mi \
 	$(PATH_SUB_CURRENT)
 vboxmouse_drv_SOURCES  = \
@@ -66,7 +66,7 @@
 vboxmouse_drv_70_LDFLAGS = -s
 vboxmouse_drv_70_INCS := \
-	../x11include/7.0 \
-	../x11include/7.0/X11 \
-	../x11include/7.0/xorg \
+	$(VBOX_PATH_X11_XORG_7_0) \
+	$(VBOX_PATH_X11_XORG_7_0)/X11 \
+	$(VBOX_PATH_X11_XORG_7_0)/xorg \
 	$(PATH_SUB_CURRENT)
 vboxmouse_drv_70_SOURCES  = \
@@ -85,7 +85,7 @@
 vboxmouse_drv_71_LDFLAGS = -s
 vboxmouse_drv_71_INCS = \
-	../x11include/7.1 \
-	../x11include/7.1/X11 \
-	../x11include/7.1/xorg \
+	$(VBOX_PATH_X11_XORG_7_1) \
+	$(VBOX_PATH_X11_XORG_7_1)/X11 \
+	$(VBOX_PATH_X11_XORG_7_1)/xorg \
 	$(PATH_SUB_CURRENT)
 vboxmouse_drv_71_SOURCES  = \
@@ -104,7 +104,7 @@
 vboxmouse_drv_14_LDFLAGS = -s
 vboxmouse_drv_14_INCS = \
-	../x11include/1.4 \
-	../x11include/1.4/X11 \
-	../x11include/1.4/xorg \
+	$(VBOX_PATH_X11_XORG_1_4) \
+	$(VBOX_PATH_X11_XORG_1_4)/X11 \
+	$(VBOX_PATH_X11_XORG_1_4)/xorg \
 	$(PATH_SUB_CURRENT)
 vboxmouse_drv_14_SOURCES  = \
@@ -125,7 +125,7 @@
 vboxmouse_drv_DEFS.solaris = __EXTENSIONS__
 vboxmouse_drv_INCS = \
-	../x11include/7.1 \
-	../x11include/7.1/X11 \
-	../x11include/7.1/xorg \
+	$(VBOX_PATH_X11_XORG_7_1) \
+	$(VBOX_PATH_X11_XORG_7_1)/X11 \
+	$(VBOX_PATH_X11_XORG_7_1)/xorg \
 	$(PATH_SUB_CURRENT)
 vboxmouse_drv_SOURCES  = \