Index: /trunk/src/VBox/Devices/Network/DevPCNet.cpp
===================================================================
--- /trunk/src/VBox/Devices/Network/DevPCNet.cpp	(revision 6651)
+++ /trunk/src/VBox/Devices/Network/DevPCNet.cpp	(revision 6652)
@@ -239,4 +239,7 @@
     bool                                afAlignment[1];
     uint32_t                            u32LinkSpeed;
+
+    STAMCOUNTER                         StatReceiveBytes;
+    STAMCOUNTER                         StatTransmitBytes;
 
 #ifdef VBOX_WITH_STATISTICS
@@ -1743,4 +1746,6 @@
                 rmd.rmd1.bam  = !CSR_PROM(pData) && is_bcast;
                 rmd.rmd2.mcnt = pkt_size;
+
+                STAM_REL_COUNTER_ADD(&pData->StatReceiveBytes, pkt_size);
             }
             else
@@ -1752,4 +1757,5 @@
                 rmd.rmd1.err  = 1;
             }
+
             /* write back, clear the own bit */
             pcnetRmdStorePassHost(pData, &rmd, PHYSADDR(pData, crda));
@@ -1879,4 +1885,5 @@
         pData->Led.Asserted.s.fWriting = pData->Led.Actual.s.fWriting = 1;
     pData->pDrv->pfnSend(pData->pDrv, pData->SendFrame.pvBuf, pData->SendFrame.cb);
+    STAM_REL_COUNTER_ADD(&pData->StatTransmitBytes, pData->SendFrame.cb);
     pData->Led.Actual.s.fWriting = 0;
     STAM_PROFILE_ADV_STOP(&pData->StatTransmitSend, a);
@@ -4491,6 +4498,12 @@
     PDMDevHlpSTAMRegisterF(pDevIns, &pData->StatTimer,              STAMTYPE_PROFILE, STAMVISIBILITY_ALWAYS, STAMUNIT_TICKS_PER_CALL, "Profiling PCNet Timer",              "/Devices/PCNet%d/Timer", iInstance);
     PDMDevHlpSTAMRegisterF(pDevIns, &pData->StatReceive,            STAMTYPE_PROFILE, STAMVISIBILITY_ALWAYS, STAMUNIT_TICKS_PER_CALL, "Profiling PCNet receive",            "/Devices/PCNet%d/Receive", iInstance);
+#endif
+    PDMDevHlpSTAMRegisterF(pDevIns, &pData->StatReceiveBytes,       STAMTYPE_COUNTER, STAMVISIBILITY_ALWAYS, STAMUNIT_BYTES,          "Amount of data received",            "/Devices/PCNet%d/ReceiveBytes", iInstance);
+#ifdef VBOX_WITH_STATISTICS
     PDMDevHlpSTAMRegisterF(pDevIns, &pData->StatTransmit,           STAMTYPE_PROFILE, STAMVISIBILITY_ALWAYS, STAMUNIT_TICKS_PER_CALL, "Profiling PCNet transmit in HC",     "/Devices/PCNet%d/Transmit/Total", iInstance);
-    PDMDevHlpSTAMRegisterF(pDevIns, &pData->StatTransmitSend,       STAMTYPE_PROFILE, STAMVISIBILITY_ALWAYS, STAMUNIT_TICKS_PER_CALL, "Profiling PCNet send transmit in HC",     "/Devices/PCNet%d/Transmit/Send", iInstance);
+#endif
+    PDMDevHlpSTAMRegisterF(pDevIns, &pData->StatTransmitBytes,      STAMTYPE_COUNTER, STAMVISIBILITY_ALWAYS, STAMUNIT_BYTES,          "Amount of data transmitted",         "/Devices/PCNet%d/TransmitBytes", iInstance);
+#ifdef VBOX_WITH_STATISTICS
+    PDMDevHlpSTAMRegisterF(pDevIns, &pData->StatTransmitSend,       STAMTYPE_PROFILE, STAMVISIBILITY_ALWAYS, STAMUNIT_TICKS_PER_CALL, "Profiling PCNet send transmit in HC","/Devices/PCNet%d/Transmit/Send", iInstance);
     PDMDevHlpSTAMRegisterF(pDevIns, &pData->StatTdtePollGC,         STAMTYPE_PROFILE, STAMVISIBILITY_ALWAYS, STAMUNIT_TICKS_PER_CALL, "Profiling PCNet TdtePoll in GC",     "/Devices/PCNet%d/TdtePollGC", iInstance);
     PDMDevHlpSTAMRegisterF(pDevIns, &pData->StatTdtePollHC,         STAMTYPE_PROFILE, STAMVISIBILITY_ALWAYS, STAMUNIT_TICKS_PER_CALL, "Profiling PCNet TdtePoll in HC",     "/Devices/PCNet%d/TdtePollHC", iInstance);
Index: /trunk/src/VBox/Frontends/VirtualBox/ui/VBoxVMInformationDlg.ui.h
===================================================================
--- /trunk/src/VBox/Frontends/VirtualBox/ui/VBoxVMInformationDlg.ui.h	(revision 6651)
+++ /trunk/src/VBox/Frontends/VirtualBox/ui/VBoxVMInformationDlg.ui.h	(revision 6652)
@@ -180,4 +180,9 @@
     mNamesMap ["/Devices/ATA1/Unit1/ReadBytes"] = tr ("Amount of data read");
     mNamesMap ["/Devices/ATA1/Unit1/WrittenBytes"] = tr ("Amount of data written");
+
+    mNamesMap ["/Devices/PCNet0/TransmitBytes"] = tr ("Amount of bytes transmitted");
+    mNamesMap ["/Devices/PCNet0/ReceiveBytes"] = tr ("Amount of bytes received");
+    mNamesMap ["/Devices/PCNet1/TransmitBytes"] = tr ("Amount of bytes transmitted");
+    mNamesMap ["/Devices/PCNet1/ReceiveBytes"] = tr ("Amount of bytes received");
 
     /* Statistics page update. */
@@ -426,7 +431,7 @@
 
     /* Network Adapters Statistics. Counters are currently missed. */
-    // result += hdrRow.arg ("nw_16px.png").arg (tr ("Dummy Network Adapters Statistics"));
-    // result += subRow.arg (tr ("Dummy Adapter 1")).arg (tr ("Dummy Adapter 2"));
-    // result += composeArticle ("B", 6, 7, 14, 15);
+    result += hdrRow.arg ("nw_16px.png").arg (tr ("Network Adapters Statistics"));
+    result += subRow.arg (tr ("Adapter 1")).arg (tr ("Adapter 2"));
+    result += composeArticle ("B", 16, 17, 18, 19);
 
     /* Show full composed page. */